#include"connthread.h"

connection::connection(int _id, QFile *_file, QUrl *_url, uint _bytes, uint _offSet):
file(_file),
url(_url),
bytes(0)
{
	conf.id=_id;
	conf.offSet=_offSet;
	conf.bytes=_bytes;
	if (url->scheme()=="ftp")
	ftpGet();
	if (url->scheme()=="http")
	httpGet();
}

void connection::run()
{
	exec();
}

void connection::done()
{
	std::printf("%d- exiting...\n",conf.id);
	quit();
	emit connfinished(conf);
}

void connection::close(bool error)
{
	std::printf("%d- exiting with error %d\n",conf.id,error);
	file->flush();
	exit(error);
	emit connfinished(conf);
}

void connection::ftpWriteBuffer()
{
	int bytesReaded=0;
	int len;
	char buff[BUFFER_SIZE];
	if(conf.bytes>BUFFER_SIZE)
	len=BUFFER_SIZE;
	else
	len=conf.bytes;
	bytesReaded=ftp->read(buff,len);
	if(bytesReaded>0){
	std::printf("tread-%d:\t%d bytes readed from socket writing at possition %d\n",conf.id,bytesReaded,conf.offSet);
	mutex.lock();
	file->seek(conf.offSet);
	file->write(buff,bytesReaded);
	mutex.unlock();
	conf.offSet+=bytesReaded;
	conf.bytes-=bytesReaded;
	bytes+=bytesReaded;
	}
	if(bytes>BUFFER_SIZE){
	bytes=0;
	emit savecfg(conf);
	}
	if(conf.bytes==0){
	disconnect(ftp,SIGNAL(readyRead()),this,SLOT(ftpWriteBuffer()));
	ftp->abort();
	std::printf("Clossing connection\n");
	}
	return;
}

void connection::httpWriteBuffer(const QHttpResponseHeader & resp)
{
	int bytesReaded=0;
	int len;
	char buff[BUFFER_SIZE];
	if(conf.bytes>BUFFER_SIZE)
	len=BUFFER_SIZE;
	else
	len=conf.bytes;
	bytesReaded=http->read(buff,len);
	if(bytesReaded>0){
	std::printf("tread-%d:\t%d bytes readed from socket writing at possition %d\n",conf.id,bytesReaded,conf.offSet);
	mutex.lock();
	file->seek(conf.offSet);
	file->write(buff,bytesReaded);
	mutex.unlock();
	conf.offSet+=bytesReaded;
	conf.bytes-=bytesReaded;
	bytes+=bytesReaded;
	}
	if(bytes>BUFFER_SIZE){
	bytes=0;
	emit savecfg(conf);
	}
	if(conf.bytes==0){
	disconnect(http,SIGNAL(readyRead(const QHttpResponseHeader &)),this,SLOT(httpWriteBuffer(const QHttpResponseHeader &)));
	http->abort();
	std::printf("Clossing connection\n");
	}
	return;
}

void connection::ftpGet()
{
	ftp=new QFtp(this);
	ftp->connectToHost(url->host());
	ftp->login();
	ftp->get(url->path(),conf.offSet);
	ftp->close();
	connect(ftp,SIGNAL(readyRead()),this,SLOT(ftpWriteBuffer()));
	connect(ftp,SIGNAL(done(bool)),this,SLOT(close(bool)));
}

void connection::httpGet()
{
	QHttpRequestHeader header("GET", url->path());
	header.setValue("Host", url->host());
	header.setValue("Range","bytes=" + QString::number(conf.offSet) + "-");
	header.setValue("Connection","close");
	http = new QHttp(this);
	http->setHost(url->host());
	http->request(header);
	connect(http,SIGNAL(readyRead(const QHttpResponseHeader & )),this,SLOT(httpWriteBuffer(const QHttpResponseHeader &)));
	connect(http,SIGNAL(done(bool)),this,SLOT(close(bool)));
}
