
#include <QtCore/QThread>
#include <QtCore/QMutex>
#include <QtCore/QUrl>
#include <QtCore/QFile>

#include <QtNetwork/QHttpRequestHeader>
#include <QtNetwork/QHttpResponseHeader>
#include <QtNetwork/QHttp>
#include <QtNetwork/QFtp>

#include "commons.h"
class connection : public QThread
{
	Q_OBJECT

public:
connection(int _id, QFile *_file, QUrl *_url, uint _bytes, uint _offSet);
void run();

signals:
void connfinished(cfg);
void savecfg(cfg);

private slots:
void done();
void close(bool);
void ftpWriteBuffer();
void httpWriteBuffer(const QHttpResponseHeader & resp);

private:
/**funtions**/
void ftpGet();
void httpGet();

/**variables**/
QMutex mutex;
QHttp *http;
QFtp  *ftp;
QFile *file;
QUrl *url;
cfg conf;
int bytes;
};
