#include <QtCore/QMap>
#include <QtCore/QThread>
#include <QtCore/QSettings>
#include <QtCore/QUrl>
#include <QtCore/QFile>
#include <QtCore/QFileInfo>

#include <QtNetwork/QHttpRequestHeader>
#include <QtNetwork/QHttpResponseHeader>
#include <QtNetwork/QHttp>
#include <QtNetwork/QFtp>

#include "commons.h"

class connection;

class mtget :public QObject
{
	Q_OBJECT

public:
mtget(const QString & _url);

signals:
void ready();
void done();

public slots:
void connFinished(cfg _conf);
void writeThreadSettings(cfg _conf);

private slots:
void httpFileInfo(const QHttpResponseHeader & resp); //retrive remote file size
void ftpFileInfo(const QUrlInfo & i);		     //retrive remote file size
void createThreads();
void createThread(int _id, QFile *_file, QUrl *_url, uint _bytes, uint _offSet);

private:
/**Funtions**/
void loadjob();
void setFileName(const QString & path);
void setFileAtributes(uint length);
cfg readThreadSettings(int _id);
void readGlobalSettings();
void writeGlobalSettings();
/**Variables**/
QSettings *settings;
int nc;
QFtp *ftpInfo;
QHttp *httpInfo;
QUrl *url;
QFile *file;
int fileChunks;
uint conn_size;
uint filelength;			//remote file size
QString fileName;			//remote file name
QMap<int, connection*> connections;
};
